﻿using Demo1;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;

namespace TestProject1
{
    
    
    /// <summary>
    ///This is a test class for Class1Test and is intended
    ///to contain all Class1Test Unit Tests
    ///</summary>
   [TestClass()]
   public class Class1Test
   {


      private TestContext testContextInstance;

      /// <summary>
      ///Gets or sets the test context which provides
      ///information about and functionality for the current test run.
      ///</summary>
      public TestContext TestContext
      {
         get
         {
            return testContextInstance;
         }
         set
         {
            testContextInstance = value;
         }
      }

      #region Additional test attributes
      // 
      //You can use the following additional attributes as you write your tests:
      //
      //Use ClassInitialize to run code before running the first test in the class
      //[ClassInitialize()]
      //public static void MyClassInitialize(TestContext testContext)
      //{
      //}
      //
      //Use ClassCleanup to run code after all tests in a class have run
      //[ClassCleanup()]
      //public static void MyClassCleanup()
      //{
      //}
      //
      //Use TestInitialize to run code before running each test
      //[TestInitialize()]
      //public void MyTestInitialize()
      //{
      //}
      //
      //Use TestCleanup to run code after each test has run
      //[TestCleanup()]
      //public void MyTestCleanup()
      //{
      //}
      //
      #endregion


      /// <summary>
      ///A test for PrivateAdd
      ///</summary>
      [TestMethod()]
      [DeploymentItem("Demo.dll")]
      public void PrivateAddTest()
      {
         Class1_Accessor target = new Class1_Accessor(); // TODO: Initialize to an appropriate value
         int lhs = 5; // TODO: Initialize to an appropriate value
         int rhs = 5; // TODO: Initialize to an appropriate value
         int expected = 10; // TODO: Initialize to an appropriate value
         int actual;
         actual = target.PrivateAdd(lhs, rhs);
         Assert.AreEqual(expected, actual);
      }

      /// <summary>
      ///A test for Div
      ///</summary>
      [TestMethod()]
      [ExpectedException(typeof(DivideByZeroException))]
      public void DivTest()
      {
         Class1 target = new Class1();
         float actual = target.Div(0, 0);
      }

      /// <summary>
      ///A test for Add
      ///</summary>
      [DataSource("Microsoft.VisualStudio.TestTools.DataSource.CSV", "|DataDirectory|\\AddBook1.csv", "AddBook1#csv", DataAccessMethod.Sequential), DeploymentItem("TestProject1\\AddBook1.csv"), TestMethod()]
      public void AddTest()
      {
         Class1 target = new Class1(); // TODO: Initialize to an appropriate value
         int lhs = (int)TestContext.DataRow["lhs"]; // TODO: Initialize to an appropriate value
         int rhs = (int)TestContext.DataRow["rhs"]; // TODO: Initialize to an appropriate value
         int expected = (int)TestContext.DataRow["total"];
         int actual;
         actual = target.Add(lhs, rhs);
         Assert.AreEqual(expected, actual);
      }

      /// <summary>
      ///A test for Div
      ///</summary>
      [TestMethod()]
      public void DivTest1()
      {
         Class1 target = new Class1(); // TODO: Initialize to an appropriate value
         int num = 10; // TODO: Initialize to an appropriate value
         int dem = 5; // TODO: Initialize to an appropriate value
         float expected = 2F; // TODO: Initialize to an appropriate value
         float actual;
         actual = target.Div(num, dem);
         Assert.AreEqual(expected, actual);
      }

      /// <summary>
      ///A test for Mul
      ///</summary>
      [TestMethod()]
      public void MulTest()
      {
         int lhs = 5; // TODO: Initialize to an appropriate value
         int rhs = 5; // TODO: Initialize to an appropriate value
         float expected = 25F; // TODO: Initialize to an appropriate value
         float actual;
         actual = Class1.Mul(lhs, rhs);
         Assert.AreEqual(expected, actual);
      }

      [TestMethod]
      public void SubTest()
      {
         Class1 target = new Class1();
         Assert.AreEqual(2, target.Sub(8, 6));
      }

      /// <summary>
      ///A test for Add
      ///</summary>
      [TestMethod()]
      public void AddTest1()
      {
         Class1 target = new Class1(); // TODO: Initialize to an appropriate value
         int lhs = 10; // TODO: Initialize to an appropriate value
         int rhs = 5; // TODO: Initialize to an appropriate value
         int expected = 15; // TODO: Initialize to an appropriate value
         int actual;
         actual = target.Add(lhs, rhs);
         Assert.AreEqual(expected, actual);
      }
   }
}
