﻿using System;
using System.Collections.Generic;
using System.Text.RegularExpressions;
using System.Windows.Input;
using System.Windows.Forms;
using System.Drawing;
using Microsoft.VisualStudio.TestTools.UITesting;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Microsoft.VisualStudio.TestTools.UITest.Extension;
using Keyboard = Microsoft.VisualStudio.TestTools.UITesting.Keyboard;


namespace TestProject1
{
   /// <summary>
   /// Summary description for DataBoundCalc
   /// </summary>
   [CodedUITest]
   public class DataBoundCalc
   {
      public DataBoundCalc()
      {
      }

      [DataSource("Microsoft.VisualStudio.TestTools.DataSource.CSV", "|DataDirectory|\\AddBook1.csv", "AddBook1#csv", DataAccessMethod.Sequential), DeploymentItem("TestProject1\\AddBook1.csv"), TestMethod]
      public void CodedUITestMethod1()
      {
         // To generate code for this test, select "Generate Code for Coded UI Test" from the shortcut menu and select one of the menu items.
         this.UIMap.StartCalc();

         foreach(char c in TestContext.DataRow["lhs"].ToString())
            this.UIMap.Click(c.ToString());

         this.UIMap.ClickPlus();

         foreach(char c in TestContext.DataRow["rhs"].ToString())
            this.UIMap.Click(c.ToString());

         this.UIMap.ClickEqual();
         this.UIMap.AssertMethodEqualsExpectedValues.Item11TextDisplayText = TestContext.DataRow["total"].ToString();
         this.UIMap.AssertMethodEquals();
         this.UIMap.CloseCalc();
      }

      #region Additional test attributes

      // You can use the following additional attributes as you write your tests:

      ////Use TestInitialize to run code before running each test 
      //[TestInitialize()]
      //public void MyTestInitialize()
      //{        
      //    // To generate code for this test, select "Generate Code for Coded UI Test" from the shortcut menu and select one of the menu items.
      //}

      ////Use TestCleanup to run code after each test has run
      //[TestCleanup()]
      //public void MyTestCleanup()
      //{        
      //    // To generate code for this test, select "Generate Code for Coded UI Test" from the shortcut menu and select one of the menu items.
      //}

      #endregion

      /// <summary>
      ///Gets or sets the test context which provides
      ///information about and functionality for the current test run.
      ///</summary>
      public TestContext TestContext
      {
         get
         {
            return testContextInstance;
         }
         set
         {
            testContextInstance = value;
         }
      }
      private TestContext testContextInstance;

      public UIMap UIMap
      {
         get
         {
            if((this.map == null))
            {
               this.map = new UIMap();
            }

            return this.map;
         }
      }

      private UIMap map;
   }
}
